package co.jp.app.dogtestbyadmin;

import co.jp.app.dto.LoginDto;
import co.jp.app.dto.RegistrationDto;
import co.jp.app.dto.UserDto;
import co.jp.app.entity.UserEntity;
import co.jp.app.repository.UserRepository;
import co.jp.app.service.UserService;
import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.mockito.InjectMocks;
import org.mockito.Mock;
import org.mockito.junit.jupiter.MockitoExtension;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.security.crypto.password.PasswordEncoder;

import static org.mockito.Mockito.when;

@SpringBootTest
@ExtendWith(MockitoExtension.class)
public class UserServiceTest {

    @Mock
    private UserRepository userRepository;

    @Mock
    private PasswordEncoder passwordEncoder;

    @InjectMocks
    private UserService userService;

    private RegistrationDto registrationDto;
    private LoginDto loginDto;
    private UserDto userDto;
    private UserEntity userEntity;

    @BeforeEach
    void setUp() {
        registrationDto = new RegistrationDto();
        registrationDto.setEmail("<EMAIL>");
        registrationDto.setName("test");
        registrationDto.setPassword("<PASSWORD>");

        loginDto = new LoginDto();
        loginDto.setEmail("<EMAIL>");
        loginDto.setPassword("<PASSWORD>");

        userDto = new UserDto();
        userDto.setEmail("<EMAIL>");
        userDto.setName("test");
    }

    @Test
    void testRegisterNewUser_normal () throws Exception{

        when(userRepository.existsByEmail(registrationDto.getEmail())).thenReturn(false);

        when(passwordEncoder.encode(registrationDto.getPassword())).thenReturn(registrationDto.getPassword());

        when(userRepository.save(userEntity)).thenAnswer(invocation -> invocation.getArgument(0));

    }

    @Test
    void testRegisterNewUser() throws Exception{

    }

    @Test
    void TestLoadUserByUsername() throws Exception{

    }
}
